<?php
/**
 * @file
 * Definition of the 'grids' panel style.
 */

// Plugin definition.
$plugin = array(
  'title' => t('--> Bootstrap Grid'),
  'description' => t('Choose a grid for region'),
  'render region' => 'circle_grids_style_render_region',
  'settings form' => 'circle_grids_style_settings_form',
);

/**
 * Render callback.
 *
 * @ingroup themeable
 */
function theme_circle_grids_style_render_region($vars) {
  $panes = $vars['panes'];
  $settings = $vars['settings'];
  $additional_classes = '';
  $items = array();

  foreach ($panes as $item) {
    $items[] = $item;
  }
  if (empty($settings['bootstrap_grid']['grid_qty'])) {
    $settings['bootstrap_grid']['grid_qty'] = '12';
  }
  if (isset($settings['bootstrap_grid']['grid_push']) && $settings['bootstrap_grid']['grid_push'] != '0') {
    $additional_classes .= ' offset' . $settings['bootstrap_grid']['grid_push'];
  }

  $rendered_items = implode($items);
  $grid_class = 'span' . $settings['bootstrap_grid']['grid_qty'] . $additional_classes;

  if ($rendered_items) {
    return '<div class="' . $grid_class . '">' . $rendered_items . '</div>';
  }
  else {
    return $rendered_items;
  }
}

/**
 * Settings form callback.
 */
function circle_grids_style_settings_form($style_settings) {

  $columns_array = array();
  $columns_array['1'] = 'One Column';
  for ($i = 2; $i <= 12; $i++) {
    $columns_array[$i] = $i . '  Columns';
  }

  $columns_push = array();
  $columns_push['0'] = 'No Push';
  for ($i = 1; $i <= 12; $i++) {
    $columns_push[$i] = $i . '  Columns';
  }

  $form['bootstrap_grid'] = array(
    '#type' => 'fieldset',
    '#title' => t('Bootstrap grid'),
    '#attributes' => array('class' => array('grid-region-form')),
  );
  $form['bootstrap_grid']['grid_qty'] = array(
    '#type' => 'select',
    '#title' => t('Grid Size'),
    '#options' => $columns_array,
    '#default_value' => (isset($style_settings['grid_qty'])) ? $style_settings['grid_qty'] : '12',
  );
  $form['bootstrap_grid']['grid_push'] = array(
    '#type' => 'select',
    '#title' => t('Grid Offset'),
    '#options' => $columns_push,
    '#default_value' => (isset($style_settings['grid_push'])) ? $style_settings['grid_push'] : '0',
  );

  return $form;
}
